Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type JoinTable

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface JoinTable

Used in the mapping of associations. It is specified on the owning side of an association.

A join table is typically used in the mapping of many-to-many and unidirectional one-to-many associations. It may also be used to map bidirectional many-to-one/one-to-many associations, unidirectional many-to-one relationships, and one-to-one associations (both bidirectional and unidirectional).

When a join table is used in mapping a relationship with an embeddable class on the owning side of the relationship, the containing entity rather than the embeddable class is considered the owner of the relationship.

If the `JoinTable` annotation is missing, the default values of the annotation elements apply. The name of the join table is assumed to be the table names of the associated primary tables concatenated together (owning side first) using an underscore.

        Example:

        @JoinTable(
            name="CUST_PHONE",
            joinColumns=
                @JoinColumn(name="CUST_ID", referencedColumnName="ID"),
            inverseJoinColumns=
                @JoinColumn(name="PHONE_ID", referencedColumnName="ID")
        )

Since:
  Java Persistence 1.0
See Also:
  `JoinColumn`, `JoinColumns`

Optional Element Summary
`java.lang.String` | `catalog` (Optional) The catalog of the table.
`JoinColumn[]` | `inverseJoinColumns` (Optional) The foreign key columns of the join table which reference the primary table of the entity that does not own the association.
`JoinColumn[]` | `joinColumns` (Optional) The foreign key columns of the join table which reference the primary table of the entity owning the association.
`java.lang.String` | `name` (Optional) The name of the join table.
`java.lang.String` | `schema` (Optional) The schema of the table.
`UniqueConstraint[]` | `uniqueConstraints` (Optional) Unique constraints that are to be placed on the table.

### name

    public abstract java.lang.String name

  (Optional) The name of the join table.

  Defaults to the concatenated names of the two associated primary entity tables, separated by an underscore.

  Default:
    ""

### catalog

    public abstract java.lang.String catalog

  (Optional) The catalog of the table.

  Defaults to the default catalog.

  Default:
    ""

### schema

    public abstract java.lang.String schema

  (Optional) The schema of the table.

  Defaults to the default schema for user.

  Default:
    ""

### joinColumns

    public abstract JoinColumn[] joinColumns

  (Optional) The foreign key columns of the join table which reference the primary table of the entity owning the association. (I.e. the owning side of the association).

  Uses the same defaults as for `JoinColumn`.

  Default:
    {}

### inverseJoinColumns

    public abstract JoinColumn[] inverseJoinColumns

  (Optional) The foreign key columns of the join table which reference the primary table of the entity that does not own the association. (I.e. the inverse side of the association).

  Uses the same defaults as for `JoinColumn`.

  Default:
    {}

### uniqueConstraints

    public abstract UniqueConstraint[] uniqueConstraints

  (Optional) Unique constraints that are to be placed on the table. These are only used if table generation is in effect.

  Defaults to no additional constraints.

  Default:
    {}

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT